# Namespace goog

code »

Base namespace for the Closure library. Checks to see goog is already defined in the current scope before assigning to prevent clobbering if base.js is loaded more than once.

## Classes

goog.Uri This class contains setters and getters for the parts of the URI.

Show:Public Protected Private

## Global Functions

code »goog.abstractMethod ( )

When defining a class Foo with an abstract method bar(), you can do: Foo.prototype.bar = goog.abstractMethod Now if a subclass of Foo fails to override bar(), an error will be thrown when bar() is invoked. Note: This does not take the name of the function to override as an argument because that would make it more difficult to obfuscate our JavaScript code.

Throws
`Error` when invoked to indicate the method should be overridden.

code »goog.addDependency ( relPath, provides, requires )

Adds a dependency from a file to the files it requires.

Parameters
relPath: `string` The path to the js file. provides: `Array` An array of strings with the names of the objects this file provides. requires: `Array` An array of strings with the names of the objects this file requires.

code »goog.addSingletonGetter ( ctor )

Adds a `getInstance` static method that always return the same instance object.

Parameters
ctor: `!Function` The constructor for the class to add the static method to.

code »goog.base ( me, opt_methodName, var_args ) ⇒ `*`

Call up to the superclass. If this is called from a constructor, then this calls the superclass contructor with arguments 1-N. If this is called from a prototype method, then you must pass the name of the method as the second argument to this function. If you do not, you will get a runtime error. This calls the superclass' method with arguments 2-N. This function only works if you use goog.inherits to express inheritance relationships between your classes. This function is a compiler primitive. At compile-time, the compiler will do macro expansion to remove a lot of the extra overhead that this function introduces. The compiler will also enforce a lot of the assumptions that this function makes, and treat it as a compiler error if you break them.

Parameters
me: `!Object` Should always be "this". opt_methodName: `*=` The method name if calling a super method. var_args: `...*` The rest of the arguments.
Returns
The return value of the superclass method.

code »`<T>` goog.bind ( fn, selfObj, var_args ) ⇒ `!Function`

Partially applies this function to a particular 'this object' and zero or more arguments. The result is a new function with some arguments of the first function pre-filled and the value of |this| 'pre-specified'.
Remaining arguments specified at call-time are appended to the pre- specified ones.
Also see: `#partial`.
Usage:

    var barMethBound = bind(myFunction, myObj, 'arg1', 'arg2');
     barMethBound('arg3', 'arg4');

Parameters
fn: `?function(this: T, ...)` A function to partially apply. selfObj: `T` Specifies the object which |this| should point to when the function is run. var_args: `...*` Additional arguments that are partially applied to the function.
Returns
A partially-applied form of the function bind() was invoked as a method of.

code »goog.bindJs_ ( fn, selfObj, var_args ) ⇒ `!Function`

A pure-JS implementation of goog.bind.

Parameters
fn: `Function` A function to partially apply. selfObj: `(Object|undefined)` Specifies the object which |this| should point to when the function is run. var_args: `...*` Additional arguments that are partially applied to the function.
Returns
A partially-applied form of the function bind() was invoked as a method of.

code »goog.bindNative_ ( fn, selfObj, var_args ) ⇒ `!Function`

A native implementation of goog.bind.

Parameters
fn: `Function` A function to partially apply. selfObj: `(Object|undefined)` Specifies the object which |this| should point to when the function is run. var_args: `...*` Additional arguments that are partially applied to the function.
Returns
A partially-applied form of the function bind() was invoked as a method of.

code »goog.cloneObject ( obj ) ⇒ `*`
Deprecated: goog.cloneObject is unsafe. Prefer the goog.object methods.

Clones a value. The input may be an Object, Array, or basic type. Objects and arrays will be cloned recursively. WARNINGS: `goog.cloneObject` does not detect reference loops. Objects that refer to themselves will cause infinite recursion. `goog.cloneObject` is unaware of unique identifiers, and copies UIDs created by `getUid` into cloned results.

Parameters
obj: `*` The value to clone.
Returns
A clone of the input value.

code »goog.define ( name, defaultValue )

Defines a named value. In uncompiled mode, the value is retreived from CLOSURE_DEFINES if the object is defined and has the property specified, and otherwise used the defined defaultValue. When compiled, the default can be overridden using compiler command-line options.

Parameters
name: `string` The distinguished name to provide. defaultValue

code »goog.exportPath_ ( name, opt_object, opt_objectToExportTo )

Builds an object structure for the provided namespace path, ensuring that names that already exist are not overwritten. For example: "a.b.c" -> a = {};a.b={};a.b.c={}; Used by goog.provide and goog.exportSymbol.

Parameters
name: `string` name of the object that this file defines. opt_object: `*=` the object to expose at the end of the path. opt_objectToExportTo: `Object=` The object to add the path to; default is |goog.global|.

code »goog.exportProperty ( object, publicName, symbol )

Exports a property unobfuscated into the object's namespace. ex. goog.exportProperty(Foo, 'staticFunction', Foo.staticFunction); ex. goog.exportProperty(Foo.prototype, 'myMethod', Foo.prototype.myMethod);

Parameters
object: `Object` Object whose static property is being exported. publicName: `string` Unobfuscated name to export. symbol: `*` Object the name should point to.

code »goog.exportSymbol ( publicPath, object, opt_objectToExportTo )

Exposes an unobfuscated global namespace path for the given object. Note that fields of the exported object *will* be obfuscated, unless they are exported in turn via this function or goog.exportProperty

Also handy for making public items that are defined in anonymous closures. ex. goog.exportSymbol('public.path.Foo', Foo); ex. goog.exportSymbol('public.path.Foo.staticFunction', Foo.staticFunction); public.path.Foo.staticFunction(); ex. goog.exportSymbol('public.path.Foo.prototype.myMethod', Foo.prototype.myMethod); new public.path.Foo().myMethod();

Parameters
publicPath: `string` Unobfuscated name to export. object: `*` Object the name should point to. opt_objectToExportTo: `Object=` The object to add the path to; default is |goog.global|.

code »goog.findBasePath_ ( )

Tries to detect the base path of the base.js script that bootstraps Closure

code »goog.getCssName ( className, opt_modifier ) ⇒ `string`

Handles strings that are intended to be used as CSS class names. This function works in tandem with @see goog.setCssNameMapping. Without any mapping set, the arguments are simple joined with a hyphen and passed through unaltered. When there is a mapping, there are two possible styles in which these mappings are used. In the BY_PART style, each part (i.e. in between hyphens) of the passed in css name is rewritten according to the map. In the BY_WHOLE style, the full css name is looked up in the map directly. If a rewrite is not specified by the map, the compiler will output a warning. When the mapping is passed to the compiler, it will replace calls to goog.getCssName with the strings from the mapping, e.g. var x = goog.getCssName('foo'); var y = goog.getCssName(this.baseClass, 'active'); becomes: var x= 'foo'; var y = this.baseClass + '-active'; If one argument is passed it will be processed, if two are passed only the modifier will be processed, as it is assumed the first argument was generated as a result of calling goog.getCssName.

Parameters
className: `string` The class name. opt_modifier: `string=` A modifier to be appended to the class name.
Returns
The class name or the concatenation of the class name and the modifier.

code »goog.getHashCode ( obj ) ⇒ `number`
Deprecated: Use goog.getUid instead.

Adds a hash code field to an object. The hash code is unique for the given object.

Parameters
obj: `Object` The object to get the hash code for.
Returns
The hash code for the object.

code »goog.getMsg ( str, opt_values ) ⇒ `string`

Gets a localized message. This function is a compiler primitive. If you give the compiler a localized message bundle, it will replace the string at compile-time with a localized version, and expand goog.getMsg call to a concatenated string. Messages must be initialized in the form: `var MSG_NAME = goog.getMsg('Hello {$placeholder}', {'placeholder': 'world'});`

Parameters
str: `string` Translatable string, places holders in the form {$foo}. opt_values: `Object=` Map of place holder name to value.
Returns
message with placeholders filled.

code »goog.getMsgWithFallback ( a, b ) ⇒ `string`

Gets a localized message. If the message does not have a translation, gives a fallback message. This is useful when introducing a new message that has not yet been translated into all languages. This function is a compiler primtive. Must be used in the form: `var x = goog.getMsgWithFallback(MSG_A, MSG_B);` where MSG_A and MSG_B were initialized with goog.getMsg.

Parameters
a: `string` The preferred message. b: `string` The fallback message.
Returns
The best translated message.

code »goog.getObjectByName ( name, opt_obj )

Returns an object based on its fully qualified external name. If you are using a compilation pass that renames property names beware that using this function will not find renamed properties.

Parameters
name: `string` The fully qualified name. opt_obj: `Object=` The object within which to look; default is |goog.global|.
Returns
The value (object or primitive) or, if not found, null.

code »goog.getPathFromDeps_ ( rule ) ⇒ `?string`

Looks at the dependency rules and tries to determine the script file that fulfills a particular rule.

Parameters
rule: `string` In the form goog.namespace.Class or project.script.
Returns
Url corresponding to the rule, or null.

code »goog.getUid ( obj ) ⇒ `number`

Gets a unique ID for an object. This mutates the object so that further calls with the same object as a parameter returns the same value. The unique ID is guaranteed to be unique across the current session amongst objects that are passed into `getUid`. There is no guarantee that the ID is unique or consistent across sessions. It is unsafe to generate unique ID for function prototypes.

Parameters
obj: `Object` The object to get the unique ID for.
Returns
The unique ID for the object.

code »goog.globalEval ( script )

Evals javascript in the global scope. In IE this uses execScript, other browsers use goog.global.eval. If goog.global.eval does not evaluate in the global scope (for example, in Safari), appends a script tag instead. Throws an exception if neither execScript or eval is defined.

Parameters
script: `string` JavaScript string.

code »goog.globalize ( obj, opt_global )
Deprecated: Properties may be explicitly exported to the global scope, but this should no longer be done in bulk.

Globalizes a whole namespace, such as goog or goog.lang.

Parameters
obj: `Object` The namespace to globalize. opt_global: `Object=` The object to add the properties to.

code »goog.identityFunction ( opt_returnValue, var_args )
Deprecated: Use goog.functions.identity instead.

The identity function. Returns its first argument.

Parameters
opt_returnValue: `*=` The single value that will be returned. var_args: `...*` Optional trailing arguments. These are ignored.
Returns
The first argument. We can't know the type -- just pass it along without type.

code »goog.importScript_ ( src )

Imports a script if, and only if, that script hasn't already been imported. (Must be called at execution time)

Parameters
src: `string` Script source.

code »goog.inHtmlDocument_ ( ) ⇒ `boolean`

Tries to detect whether is in the context of an HTML document.

Returns
True if it looks like HTML document.

code »goog.inherits ( childCtor, parentCtor )

Inherit the prototype methods from one constructor into another. Usage:

     function ParentClass(a, b) { }
     ParentClass.prototype.foo = function(a) { }

     function ChildClass(a, b, c) {
       goog.base(this, a, b);
     }
     goog.inherits(ChildClass, ParentClass);

     var child = new ChildClass('a', 'b', 'see');
     child.foo(); // works

In addition, a superclass' implementation of a method can be invoked as follows:

     ChildClass.prototype.foo = function(a) {
       ChildClass.superClass_.foo.call(this, a);
       // other code
     };

Parameters
childCtor: `Function` Child class. parentCtor: `Function` Parent class.

code »goog.isArray ( val ) ⇒ `boolean`

Returns true if the specified value is an array

Parameters
val: `*` Variable to test.
Returns
Whether variable is an array.

code »goog.isArrayLike ( val ) ⇒ `boolean`

Returns true if the object looks like an array. To qualify as array like the value needs to be either a NodeList or an object with a Number length property.

Parameters
val: `*` Variable to test.
Returns
Whether variable is an array.

code »goog.isBoolean ( val ) ⇒ `boolean`

Returns true if the specified value is a boolean

Parameters
val: `*` Variable to test.
Returns
Whether variable is boolean.

code »goog.isDateLike ( val ) ⇒ `boolean`

Returns true if the object looks like a Date. To qualify as Date-like the value needs to be an object and have a getFullYear() function.

Parameters
val: `*` Variable to test.
Returns
Whether variable is a like a Date.

code »goog.isDef ( val ) ⇒ `boolean`

Returns true if the specified value is not |undefined|. WARNING: Do not use this to test if an object has a property. Use the in operator instead. Additionally, this function assumes that the global undefined variable has not been redefined.

Parameters
val: `*` Variable to test.
Returns
Whether variable is defined.

code »goog.isDefAndNotNull ( val ) ⇒ `boolean`

Returns true if the specified value is defined and not null

Parameters
val: `*` Variable to test.
Returns
Whether variable is defined and not null.

code »goog.isFunction ( val ) ⇒ `boolean`

Returns true if the specified value is a function

Parameters
val: `*` Variable to test.
Returns
Whether variable is a function.

code »goog.isNull ( val ) ⇒ `boolean`

Returns true if the specified value is |null|

Parameters
val: `*` Variable to test.
Returns
Whether variable is null.

code »goog.isNumber ( val ) ⇒ `boolean`

Returns true if the specified value is a number

Parameters
val: `*` Variable to test.
Returns
Whether variable is a number.

code »goog.isObject ( val ) ⇒ `boolean`

Returns true if the specified value is an object. This includes arrays and functions.

Parameters
val: `*` Variable to test.
Returns
Whether variable is an object.

code »goog.isProvided_ ( name ) ⇒ `boolean`

Check if the given name has been goog.provided. This will return false for names that are available only as implicit namespaces.

Parameters
name: `string` name of the object to look for.
Returns
Whether the name has been provided.

code »goog.isString ( val ) ⇒ `boolean`

Returns true if the specified value is a string

Parameters
val: `*` Variable to test.
Returns
Whether variable is a string.

code »goog.mixin ( target, source )

Copies all the members of a source object to a target object. This method does not work on all browsers for all objects that contain keys such as toString or hasOwnProperty. Use goog.object.extend for this purpose.

Parameters
target: `Object` Target. source: `Object` Source.

code »goog.now ( ) ⇒ `number`

Returns
An integer value representing the number of milliseconds between midnight, January 1, 1970 and the current time.

code »goog.nullFunction ( ) ⇒ `void`

Null function used for default values of callbacks, etc.

Returns
Nothing.

code »goog.partial ( fn, var_args ) ⇒ `!Function`

Like bind(), except that a 'this object' is not required. Useful when the target function is already bound. Usage: var g = partial(f, arg1, arg2); g(arg3, arg4);

Parameters
fn: `Function` A function to partially apply. var_args: `...*` Additional arguments that are partially applied to fn.
Returns
A partially-applied form of the function bind() was invoked as a method of.

code »goog.provide ( name )

Creates object stubs for a namespace. The presence of one or more goog.provide() calls indicate that the file defines the given objects/namespaces. Build tools also scan for provide/require statements to discern dependencies, build dependency files (see deps.js), etc.

Parameters
name: `string` Namespace provided by this file in the form "goog.package.part".

code »goog.removeHashCode ( obj )
Deprecated: Use goog.removeUid instead.

Removes the hash code field from an object.

Parameters
obj: `Object` The object to remove the field from.

code »goog.removeUid ( obj )

Removes the unique ID from an object. This is useful if the object was previously mutated using `goog.getUid` in which case the mutation is undone.

Parameters
obj: `Object` The object to remove the unique ID field from.

code »goog.require ( name )

Implements a system for the dynamic resolution of dependencies that works in parallel with the BUILD system. Note that all calls to goog.require will be stripped by the JSCompiler when the --closure_pass option is used.

Parameters
name: `string` Namespace to include (as was given in goog.provide()) in the form "goog.package.part".

code »goog.scope ( fn )

Allow for aliasing within scope functions. This function exists for uncompiled code - in compiled code the calls will be inlined and the aliases applied. In uncompiled code the function is simply run since the aliases as written are valid JavaScript.

Parameters
fn: `function()` Function to call. This function can contain aliases to namespaces (e.g. "var dom = goog.dom") or classes (e.g. "var Timer = goog.Timer").

code »goog.setCssNameMapping ( mapping, opt_style )

Sets the map to check when returning a value from goog.getCssName(). Example:

     goog.setCssNameMapping({
       "goog": "a",
       "disabled": "b",
     });

     var x = goog.getCssName('goog');
     // The following evaluates to: "a a-b".
     goog.getCssName('goog') + ' ' + goog.getCssName(x, 'disabled')

When declared as a map of string literals to string literals, the JSCompiler will replace all calls to goog.getCssName() using the supplied map if the --closure_pass flag is set.

Parameters
mapping: `!Object` A map of strings to strings where keys are possible arguments to goog.getCssName() and values are the corresponding values that should be returned. opt_style: `string=` The style of css name mapping. There are two valid options: 'BY_PART', and 'BY_WHOLE'.

code »goog.setTestOnly ( opt_message )

Marks that the current file should only be used for testing, and never for live code in production. In the case of unit tests, the message may optionally be an exact namespace for the test (e.g. 'goog.stringTest'). The linter will then ignore the extra provide (if not explicitly defined in the code).

Parameters
opt_message: `string=` Optional message to add to the error that's raised when used in production code.

code »goog.typeOf ( value ) ⇒ `string`

This is a "fixed" version of the typeof operator. It differs from the typeof operator in such a way that null returns 'null' and arrays return 'array'.

Parameters
value: `*` The value to get the type of.
Returns
The name of the type.

code »goog.writeScriptTag_ ( src ) ⇒ `boolean`

The default implementation of the import function. Writes a script tag to import the script.

Parameters
src: `string` The script source.
Returns
True if the script was imported, false otherwise.

code »goog.writeScripts_ ( )

Resolves dependencies based on the dependencies added using addDependency and calls importScript_ in the correct order.

## Global Properties

code »goog.DEPENDENCIES_ENABLED : `boolean`

True if goog.dependencies_ is available.

code »goog.UID_PROPERTY_ : `string`

Name for unique ID property. Initialized in a way to help avoid collisions with other closure javascript on the same page.

code »goog.basePath : `string`

Path for included scripts

code »goog.cssNameMappingStyle_ : `(string|undefined)`

Optional obfuscation style for CSS class names. Should be set to either 'BY_WHOLE' or 'BY_PART' if defined.

code »goog.cssNameMapping_ : `(Object|undefined)`

Optional map of CSS class names to obfuscated names used with goog.getCssName().

code »goog.dependencies_ : `Object`

This object is used to keep track of dependencies and other data that is used for loading scripts

code »goog.evalWorksForGlobals_ : `?boolean`

Indicates whether or not we can call 'eval' directly to eval code in the global scope. Set to a Boolean by the first call to goog.globalEval (which empirically tests whether eval works for globals). @see goog.globalEval

code »goog.global : `global this`

Reference to the global context. In most cases this will be 'window'.

code »goog.implicitNamespaces_ : `Object`

Namespaces implicitly defined by goog.provide. For example, goog.provide('goog.events.Event') implicitly declares that 'goog' and 'goog.events' must be namespaces.

code »goog.included_ : `Object`

Object used to keep track of urls that have already been added. This record allows the prevention of circular dependencies.

code »goog.instantiatedSingletons_ : `!Array`

All singleton classes that have been instantiated, for testing. Don't read it directly, use the `goog.testing.singleton` module. The compiler removes this variable if unused.

code »goog.uidCounter_ : `number`

Counter for UID.

## Compiler Constants

code »goog.DEBUG : `boolean`
code »goog.ENABLE_DEBUG_LOADER : `boolean`
code »goog.LOCALE : `string`
code »goog.NATIVE_ARRAY_PROTOTYPES : `boolean`
code »goog.TRUSTED_SITE : `boolean`